SystemOrganization addCategory: #'Glamour-Test-Morphic'!

TestCase subclass: #GLMMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Test-Morphic'!

!GLMMorphicTest methodsFor: 'as yet unclassified' stamp: 'tg 11/16/2009 06:24'!
repeatAssert: aBlock equals: aResult

	self assert: (self wait: 2 until: aBlock evaluatesTo: aResult)! !

!GLMMorphicTest methodsFor: 'as yet unclassified' stamp: 'tg 11/13/2009 09:34'!
testChildrenBlock

	| browser window check |
	browser := GLMFinder new.
	check := false.
	browser tree
		children: [:each | check := true. #()].
	window := browser openOn: ($a to: $d).
	self repeatAssert: [check] equals: true.
	window delete! !

!GLMMorphicTest methodsFor: 'as yet unclassified' stamp: 'tg 11/13/2009 09:33'!
testChildrenBlockTakesEntity

	| browser receivedEntity window |
	browser := GLMFinder new.
	receivedEntity := nil.
	browser tree
		children: [:each :entity | receivedEntity := entity. #()].
	window := browser openOn: ($a to: $d).
	self repeatAssert: [receivedEntity] equals: ($a to: $d).
	window delete! !

!GLMMorphicTest methodsFor: 'as yet unclassified' stamp: 'tg 11/13/2009 09:40'!
testSpawnFinder

	| browser window check |
	browser := GLMFinder new.
	window := browser openOn: ($a to: $d).
	self repeatAssert: [window submorphs last class] equals: GLMPaneScroller.
	window delete! !

!GLMMorphicTest methodsFor: 'as yet unclassified' stamp: 'tg 11/16/2009 06:25'!
testSpawnTableLayoutBrowser

	| browser window check |
	browser := GLMTableLayoutBrowser new.
	window := browser openOn: ($a to: $d).
	self repeatAssert: [
		window submorphs last 
					submorphs last 
						submorphs last 
							submorphs last class] equals: LazyMorphTreeMorph.
	window delete! !

!GLMMorphicTest methodsFor: 'as yet unclassified' stamp: 'tg 11/13/2009 09:15'!
wait: maxWaitSeconds until: validateBlock evaluatesTo: expectedResult
	"Evaluate validateBlock until it returns expectedResult or 
maxWaitSeconds have passed,
	 pausing between evaluations.  Return the last result of validateBlock 
value"

	| startTime result |
	startTime := Time secondClock.
	[result := validateBlock value = expectedResult] whileFalse:
			[Time secondClock - startTime > maxWaitSeconds ifTrue: [^result].
			(Delay forMilliseconds: 50) wait].
	^ result
! !
